package de.fzj.unicore.cisprovider.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import de.fzj.unicore.uas.util.LogUtil;
/** 
 * Utility class to handle date/calendar objects
 *  */
public class DateUtil {
	public static Calendar toCalendar(String strDate) {
		return toCalendar(strDate, "dd.mm.yyyy");
	}
	
	public static Calendar toCalendar(String strDate, String strFormat) {
		DateFormat formatter;
		Date date = null;
		formatter = new SimpleDateFormat(strFormat);
		try {
			date = (Date) formatter.parse(strDate);
		} catch (ParseException e) {
			LogUtil.logException("Failed to parse string date", e);
		}
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		return cal;
	}
}
