package de.fzj.unicore.bes.security;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringReader;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import de.fzj.unicore.bes.BES;
import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.uas.util.LogUtil;

/**
 * @deprecated
 */
public class UsernameTokenValidator extends SecurityValidator {

    private final static Logger logger = LogUtil.getLogger(LogUtil.SECURITY, UsernameTokenValidator.class);

    @Override
    @SuppressWarnings("unchecked")
    public boolean validate(Map<String, String> securityData) throws SecurityException {
        String uname = securityData.get(SecurityConstant.USERNAME);
        String pwd = securityData.get(SecurityConstant.PASSWORD);
        Element element = getRootElement(UAS.getProperty(BES.SECURITY_USER_FILE));

        List<Element> list = element.getChildren();
        for (Element elem : list) {
            String unameXml = elem.getAttribute("name").getValue();
            String pwdXml = elem.getAttribute("password").getValue();
            //XXX: not sure if you can ignorecase in passwords
            if (uname.equalsIgnoreCase(unameXml) && pwd.equalsIgnoreCase(pwdXml)) {
                logger.debug("Authentication successful.");
                return true;
            }
        }
        return false;
    }

    protected Element getRootElement(String fileName) {
        FileInputStream fileInputStream = null;
        try {
            fileInputStream = new FileInputStream(fileName);
        } catch (FileNotFoundException e) {
            logger.error("", e);
        } finally {
            if (fileInputStream == null) {
                return null;
            }
        }

        SAXBuilder saxBuilder = new SAXBuilder();
        saxBuilder.setEntityResolver(new EntityResolver() {
            public InputSource resolveEntity(String publicId, String systemId) throws SAXException, IOException {
                return new InputSource(new StringReader(""));
            }
        });
        
        Document document = null;
        try {
            document = saxBuilder.build(fileInputStream);
            fileInputStream.close();
        } catch (JDOMException e) {
            logger.error("", e);
        } catch (IOException e) {
            logger.error("", e);
        } finally {
            if (document == null) {
                return null;
            }
        }
        Element element = document.getRootElement();
        return element;
    }
}
