package de.fzj.unicore.uas.client;

public interface UFTPConstants {
	/**
	 * client host 
	 */
	public static final String PARAM_CLIENT_HOST="uftp.client.host";

	/**
	 * requested number of parallel data streams
	 */
	public static final String PARAM_STREAMS="uftp.streams";

	/**
	 * parameter for configuring server limit for number of streams 
	 */
	public static final String PARAM_STREAMS_LIMIT="uftp.streams.limit";

	/**
	 * server host 
	 */
	public static final String PARAM_SERVER_HOST="uftp.server.host";

	/**
	 * server host 
	 */
	public static final String PARAM_SERVER_PORT="uftp.server.port";

	/**
	 * secret, i.e. authz token that the server should expect for authorising the
	 * present transfer
	 */
	public static final String PARAM_SECRET="uftp.secret";

	/**
	 * key for encrypting and decrypting data. This will be generated on the server
	 * if the client requests it by setting PARAM_ENABLE_ENCRYPTION to "true" when creating the transfer.
	 */
	public static final String PARAM_ENCRYPTION_KEY="uftp.encryption_key";

	/**
	 * enable encryption by setting this to "true"
	 */
	public static final String PARAM_ENABLE_ENCRYPTION="uftp.encryption";

	
	/**
	 * extra property for configuring the UFTP client side:
	 * <ul>
	 * <li>if unset or set to "true", the Java UFTP client code will be run
	 * directly within the JVM, which will work only if the UNICORE/X has access to
	 * the target file system</li>
	 * <li>if set to <code>false</code>, the Java UFTP client code will be run via the TSI</li>
	 * </ul>
	 */
	public static final String PARAM_CLIENT_LOCAL="uftp.client.local";

	/**
	 * property for configuring the path to the client executable (location of 'uftp.sh')
	 */
	public static final String PARAM_CLIENT_EXECUTABLE="uftp.client.executable";

	/**
	 * property for configuring the tsi host 
	 */
	public static final String PARAM_CLIENT_TSI_HOST="uftp.client.tsihost";

	/**
	 * property for disabling ssl on the command port (useful for testing)
	 */
	public static final String PARAM_COMMAND_SSL_DISABLE="uftp.command.ssl.disable";

	/**
	 * property for setting the command host
	 */
	public static final String PARAM_COMMAND_HOST="uftp.command.host";

	/**
	 * property for setting the command port
	 */
	public static final String PARAM_COMMAND_PORT="uftp.command.port";
	
	/**
	 * property for setting the file read/write buffer size in kbytes
	 */
	public static final String PARAM_BUFFERSIZE="uftp.buffersize";
	
}
