package de.fzj.unicore.uas.security;

import org.junit.Test;
import static org.junit.Assert.*;

public class TestClientProperties {

	@Test
	public void testLoadKS_P12()throws Exception{
		String name="src/test/resources/server-keystore.p12";
		String passwd="the!njs";
		ClientProperties cp=new ClientProperties();
		cp.setKeystore(name);
		cp.setKeystorePassword(passwd);
		assertNotNull(cp.getETDSettings().getIssuerCertificateChain());
		assertNotNull(cp.getPublicKey());
	
	}
	
	@Test
	public void testLoadKS_JKS()throws Exception{
		String name="src/test/resources/user-keystore.jks";
		String passwd="the!user";
		ClientProperties cp=new ClientProperties();
		cp.setKeystore(name);
		cp.setKeystorePassword(passwd);
		assertNotNull(cp.getETDSettings().getIssuerCertificateChain());
		assertNotNull(cp.getPublicKey());
	}
}
