package de.fzj.unicore.uas;

import java.util.Properties;

import de.fzj.unicore.wsrflite.security.ISecurityProperties;
import de.fzj.unicore.wsrflite.security.UASSecurityProperties;
import de.fzj.unicore.wsrflite.xfire.JettyTestCase;

public abstract class SSLJettyTestCase extends JettyTestCase{

	protected ISecurityProperties getServerSideSecurityProperties() throws Exception {
		Properties u = new Properties();
		u.setProperty(ISecurityProperties.WSRF_SSL, "true");
		//optional for testcase!
		u.setProperty(ISecurityProperties.WSRF_SSL_CLIENTAUTH, "true");
		u.setProperty(ISecurityProperties.WSRF_SSL_KEYSTORE, "src/main/certs/server-keystore.p12");
		u.setProperty(ISecurityProperties.WSRF_SSL_KEYPASS, "the!njs");
		u.setProperty(ISecurityProperties.WSRF_SSL_KEYALIAS, "njs test certificate");
		u.setProperty(ISecurityProperties.WSRF_SSL_KEYTYPE, "pkcs12");
		u.setProperty(ISecurityProperties.WSRF_SSL_TRUSTSTORE, "src/main/certs/server-truststore.jks");
		u.setProperty(ISecurityProperties.WSRF_SSL_TRUSTPASS, "the!njs");
		u.setProperty(ISecurityProperties.WSRF_SSL_TRUSTTYPE, "jks");
		UASSecurityProperties sec = new UASSecurityProperties(kernel.getProperties(), u);
		sec.setSignMessage(true);
		sec.getETDSettings().setExtendTrustDelegation(true);
		return sec;
	}
	
	protected String getBaseurl(){
		return "https://localhost:"+getPort()+"/services";
	}
	
}
