package de.fzj.unicore.uas.impl;

import javax.xml.namespace.QName;

import junit.framework.TestCase;

import org.apache.xmlbeans.XmlObject;

import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.uas.impl.tss.rp.ExecutionEnvironmentRP;
import de.fzj.unicore.uas.xnjs.XNJSFacade;
import de.fzj.unicore.wsrflite.Kernel;
import de.fzj.unicore.wsrflite.Resource;
import de.fzj.unicore.wsrflite.xmlbeans.impl.WSResourceImpl;
import eu.unicore.jsdl.extensions.ExecutionEnvironmentDescriptionDocument;

public class TestExecutionEnvRP extends TestCase{

	Kernel kernel;
	
	@Override
	protected void setUp(){
		kernel=new Kernel();
		kernel.setProperty(UAS.TSF_XNJS_CONFIGFILE, "src/test/resources/xnjs.xml");
		XNJSFacade.get(null,kernel);
	}
	
	public void testRP(){
		ExecutionEnvironmentRP rp=new ExecutionEnvironmentRP(createMockResource(),null);
		XmlObject[] xml=rp.update().getXml();
		ExecutionEnvironmentDescriptionDocument time=null;
		ExecutionEnvironmentDescriptionDocument mpi=null;
		System.out.println("Number of defined execution environments: "+xml.length);
		assertEquals(2,xml.length);
		
		for(XmlObject o: xml){
			ExecutionEnvironmentDescriptionDocument eed=(ExecutionEnvironmentDescriptionDocument)o;
			String name=eed.getExecutionEnvironmentDescription().getName();
			if("TIME".equals(name)){
				time=eed;
			}
			else if("OpenMPI".equals(name)){
				mpi=eed;
			}
		}
		checkTimeEE(time);
		checkMPI(mpi);
	}
	
	private void checkTimeEE(ExecutionEnvironmentDescriptionDocument time){
		assertNotNull(time);
		assertEquals("1.0",time.getExecutionEnvironmentDescription().getVersion());
	}
	
	private void checkMPI(ExecutionEnvironmentDescriptionDocument mpi){
		assertNotNull(mpi);
		assertEquals(1,mpi.getExecutionEnvironmentDescription().getPreCommandArray().length);
	}
	
	
	private Resource createMockResource(){
		WSResourceImpl wsr=new WSResourceImpl() {
			@Override
			public QName getResourcePropertyDocumentQName() {
				// TODO Auto-generated method stub
				return null;
			}
		};
		Kernel kernel=new Kernel();
		wsr.setKernel(kernel);
		return wsr;
	}
}
