package de.fzj.unicore.uas.impl;

import javax.xml.namespace.QName;

import junit.framework.TestCase;

import org.unigrids.services.atomic.types.TextInfoType;

import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.uas.impl.tss.rp.TextInfoResourceProperty;
import de.fzj.unicore.wsrflite.Kernel;
import de.fzj.unicore.wsrflite.Resource;
import de.fzj.unicore.wsrflite.xmlbeans.impl.WSResourceImpl;

public class TestTextInfoRP extends TestCase{

	public void test1(){
		Resource wsr=createMockResource();
		wsr.getKernel().setProperty(UAS.TSF_XNJS_CONFIGFILE,"src/test/resources/xnjs.xml");
		TextInfoResourceProperty rp=new TextInfoResourceProperty(wsr,null);
		TextInfoType ti=TextInfoType.Factory.newInstance();
		ti.setName("foo");
		ti.setValue("bar");
		rp.add(ti);
		assertTrue(rp.contains("foo"));
		assertEquals("bar",rp.getInfo("foo"));
		
		//check values defined in "src/test/resources/simpleidb"
		assertTrue(rp.contains("TEST1"));
		assertTrue("This is a test value".equals(rp.getInfo("TEST1")));
		assertTrue(rp.contains("TEST2"));
		assertTrue("This is a second test value".equals(rp.getInfo("TEST2")));
	}
	
	private Resource createMockResource(){
		WSResourceImpl wsr=new WSResourceImpl() {
			@Override
			public QName getResourcePropertyDocumentQName() {
				// TODO Auto-generated method stub
				return null;
			}
		};
		Kernel kernel=new Kernel();
		wsr.setKernel(kernel);
		return wsr;
	}
}
