package de.fzj.unicore.uas.impl.registry;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.io.File;

import org.apache.commons.io.FileUtils;
import org.junit.Test;

import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.wsrflite.Kernel;
import de.fzj.unicore.wsrflite.events.PropertyFileChangeEvent;
import de.fzj.unicore.wsrflite.xmlbeans.client.ExternalRegistryClient;


public class TestRegistryHandler {

	@Test
	public void testURLUpdate()throws Exception{
		FileUtils.deleteQuietly(new File("target", "data"));
		Kernel k=new Kernel();
		k.setProperty(UAS.EXTERNAL_REGISTRY_USE, "true");
		k.setProperty(UAS.EXTERNAL_REGISTRY_KEY+".1", "http://registry1");
		RegistryHandler rh=RegistryHandler.get(k);
		assertEquals(1,rh.getExternalRegistryURLs().length);
		k.setProperty(UAS.EXTERNAL_REGISTRY_KEY+".2", "http://registry2");
		k.notifyObservers(new PropertyFileChangeEvent(null));
		assertEquals(2,rh.getExternalRegistryURLs().length);
		k.setProperty(UAS.EXTERNAL_REGISTRY_KEY+".2", null);
		k.notifyObservers(new PropertyFileChangeEvent(null));
		assertEquals(1,rh.getExternalRegistryURLs().length);
		ExternalRegistryClient erc=rh.getExternalRegistryClient();
		assertNotNull(erc);
	}

}
