/*
 * Copyright (c) 2011 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE file for licencing information.
 *
 * Created on 29-07-2011
 * Author: K. Benedyczak <golbi@mat.umk.pl>
 */
package de.fzj.unicore.uas.util;

import static de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.PREFIX;
import static de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.SUFFIX_CLASS;
import static de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.SUFFIX_PATH;
import static de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.SUFFIX_PROTOCOLS;
import static de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.SUFFIX_TYPE;

import java.util.Properties;

import junit.framework.Assert;

import org.junit.Test;

import de.fzj.unicore.uas.UAS;
import de.fzj.unicore.uas.util.AddOnStorageDescriptionFactory.AddOnStorageDescription;


public class TestAddOnStorageDescriptorFactory {
	@Test
	public void test() {
		Properties p = new Properties();
		p.setProperty(PREFIX, "foo");
		p.setProperty(PREFIX+"NNN", "name");
		p.setProperty(PREFIX+"NNN"+SUFFIX_PATH , "path");
		p.setProperty(PREFIX+"NNN"+SUFFIX_CLASS, "someClass");
		p.setProperty(PREFIX+"NNN"+SUFFIX_PROTOCOLS, "BFT RBYTEIO");
		p.setProperty(PREFIX+"NNN"+SUFFIX_TYPE, "CUSTOM");
		p.setProperty(PREFIX+"NNN"+".other", "dd");
		p.setProperty(PREFIX+"NNN"+".oneMore.fff", "dd");
		
		p.setProperty(PREFIX+"NNN2", "name2");
		p.setProperty(PREFIX+"NNN2"+SUFFIX_PATH , "path");
		p.setProperty(PREFIX+"NNN2"+SUFFIX_CLASS, "someClass");
		p.setProperty(PREFIX+"NNN2"+SUFFIX_PROTOCOLS, "BFT RBYTEIO");
		p.setProperty(PREFIX+"NNN2"+SUFFIX_TYPE, "CUSTOM");
		p.setProperty(PREFIX+"NNN2"+".other", "dd");
		p.setProperty(PREFIX+"NNN2"+".oneMore.fff", "dd");
		p.setProperty(UAS.TSS_FORCE_UNIQUE_STORAGE_IDS, "true");
		
		
		AddOnStorageDescriptionFactory factory = new AddOnStorageDescriptionFactory(p);
		
		Assert.assertEquals(2, factory.getDescriptions().size());
		for (AddOnStorageDescription desc: factory.getDescriptions()) {
			Assert.assertTrue(desc.getName().equals("name") || desc.getName().equals("name2"));
			Assert.assertEquals("path", desc.getPathSpec());
			Assert.assertEquals("BFT RBYTEIO", p.get(desc.getProtocolsProperty()));
			Assert.assertEquals("someClass", desc.getStorageClass());
			Assert.assertEquals("CUSTOM", desc.getType());
			Assert.assertEquals(6, desc.getAdditionalProperties().size());
		}
	}
}
