package de.fzj.unicore.uas.fts.udt;

import org.unigrids.services.atomic.types.ProtocolType;

import de.fzj.unicore.uas.client.FileTransferClient;
import de.fzj.unicore.uas.client.UDTClient;
import de.fzj.unicore.uas.xnjs.U6FileExportBase;
import de.fzj.unicore.xnjs.Configuration;

public class UDTExport extends U6FileExportBase{

	public UDTExport(Configuration config){
		super(config);
	}
	
	@Override
	protected void doRun() throws Exception {
		UDTClient udt=((UDTClient)ftc);
		udt.run();
		while(true){
			Thread.sleep(500);
			udt.checkError();
			long size=udt.getSourceFileSize();
			transferredBytes=udt.getTransferredBytes();
			if(logger.isTraceEnabled()){
				logger.trace("Size of file to transfer: "+size);
				logger.trace("Bytes transferred:        "+transferredBytes);
			}
			if(transferredBytes>0 && transferredBytes>=size)break;
		}
	}

	@Override
	protected FileTransferClient getFTClient() throws Exception {
		String url=fileTransferInstanceEpr.getAddress().getStringValue();
		UDTClient c=new UDTClient(url, fileTransferInstanceEpr,sec);
		c.setClient(client);
		c.setConfiguration(configuration);
		c.setExportMode(true);
		c.setLocalFile(localFile);
		String host=configuration.getProperty(UDTSession.UDT_HOST, UDTSession.getLocalhostAddress());
		c.setMyHost(host);
		return c;
	}

	@Override
	public String getProtocol() {
		return ProtocolType.UDT.toString();
	}

}
